#!/bin/bash
# Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2024. All rights reserved. 2-clause BSD license.
# https://fsen.ru/linux/settings#iron
# rm -f /tmp/iron.sh && wget -qP /tmp https://fsen.ru/inc/doc/linux/iron.sh && chmod +x /tmp/iron.sh && /tmp/iron.sh
#-----------------------------------------------------------------------
# Настраиваем браузер SRWare Iron
# rm -f ~/.config/chromium/Default/Preferences
# geany ~/.config/chromium/Default/Preferences
# geany ~/'.config/chromium/Local State'

#-----------------------------------------------------------------------
# После настройки руками:
#-----------------------------------------------------------------------
# 1) Внешний вид: Тема - Just Black
# 2) Поисковая система - DuckDuckGo
# 3) Запуск Chrome - Ранее открытые вкладки

# Расширения
# AdBlocker Ultimate https://chromewebstore.google.com/detail/adblocker-ultimate/ohahllgiabjaoigichmmfljhkcfikeof
# Обход блокировок Рунета - и сразу обновить базу в настройках расширения. В том числе Ютуб исцеляет, иконки видно итд.
#   https://chromewebstore.google.com/detail/%D0%BE%D0%B1%D1%85%D0%BE%D0%B4-%D0%B1%D0%BB%D0%BE%D0%BA%D0%B8%D1%80%D0%BE%D0%B2%D0%BE%D0%BA-%D1%80%D1%83%D0%BD%D0%B5%D1%82%D0%B0/npgcnondjocldhldegnakemclmfkngch
# Channel Blocker + загрузить свой список блокировок https://chromewebstore.google.com/detail/channel-blocker/nfkmalbckemmklibjddenhnofgnfcdfp
# Return YouTube Dislike https://chromewebstore.google.com/detail/return-youtube-dislike/gebbhagfogifgggkldgodflihgfeippi
# YoutubeAlgorithmKiller - Убирает дегрод контент в виде Shorts (коротких роликов) https://chromewebstore.google.com/detail/youtubealgorithmkiller/fpmfjjggginpiblbalhohnpnkcggnejn
# SaveFrom для загрузки видеороликов с Ютуба https://ru.savefrom.net/20/userjs-for-google-chrome.php

#-----------------------------------------------------------------------
# Запускаем программу для генерации конфигов по умолчанию
#-----------------------------------------------------------------------
nohup /usr/share/iron/chrome-wrapper &
sleep 10
killall -15 chrome
sleep 5

#-----------------------------------------------------------------------
# Я и Google - Синхронизация сервисов Google - выключить Allow Iron sign-in
#-----------------------------------------------------------------------
# Ютуб отлогинивается постояннно.
sed -i 's/signin":{"allowed":true},"spellcheck/signin":{"allowed":true,"allowed_on_next_startup":false},"spellcheck/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Автозаполнение и пароли - Менеджер паролей - Настройки - Предлагать сохранение паролей - отключить
#-----------------------------------------------------------------------
sed -i 's/"default_apps_install_state"/"credentials_enable_service":false,"default_apps_install_state"/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Конфиденциальность и безопасность - Сторонние файлы cookie - Разрешить использование сторонних файлов cookie
#-----------------------------------------------------------------------
#sed -i 's/pref_version":1},"created_by_version/pref_version":1},"cookie_controls_mode":0,"created_by_version/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Внешний вид
#-----------------------------------------------------------------------
# Не Показывать кнопку "Главная страница" - где-то ещё, где не понять..
#sed -i 's/show_home_button":"[A-Za-z0-9]*"/show_home_button":"7E99030D80842F6B31CFF7A701F51FDDE0C2D401D249ABEA6B2AE80DCC1EA5BA"/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Меняем домашнюю страницу
#-----------------------------------------------------------------------
sed -i 's/"homepage":"http:\/\/iron-start.com"/"homepage":"https:\/\/fsen.ru\/linux"/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Поисковая система DuckDuckGo - руками - глючит, хэш ключи разные, видимо где-то ещё..
#-----------------------------------------------------------------------
# sed -i 's/"default_apps_install_state":3,"devtools"/"default_apps_install_state":3,"default_search_provider":{"synced_guid":"485bf7d3-0215-45af-87dc-538868000094"},"default_search_provider_data":{"template_url_data":{"alternate_urls":["{google:baseURL}#q={searchTerms}","{google:baseURL}search#q={searchTerms}","{google:baseURL}webhp#q={searchTerms}","{google:baseURL}s#q={searchTerms}","{google:baseURL}s?q={searchTerms}"],"contextual_search_url":"","created_by_policy":false,"created_from_play_api":false,"date_created":"0","doodle_url":"","enforced_by_policy":false,"favicon_url":"","id":"4","image_search_branding_label":"","image_translate_source_language_param_key":"","image_translate_target_language_param_key":"","image_translate_url":"","image_url":"{google:baseURL}searchbyimage\/upload","image_url_post_params":"encoded_image={google:imageThumbnail},image_url={google:imageURL},sbisrc={google:imageSearchSource},original_width={google:imageOriginalWidth},original_height={google:imageOriginalHeight}","input_encodings":["UTF-8"],"is_active":1,"keyword":"google.com","last_modified":"0","last_visited":"0","logo_url":"","new_tab_url":"{google:baseURL}_\/chrome\/newtab?{google:RLZ}{google:instantExtendedEnabledParameter}ie={inputEncoding}","originating_url":"","preconnect_to_search_url":false,"prefetch_likely_navigations":false,"prepopulate_id":94,"safe_for_autoreplace":true,"search_intent_params":[],"search_url_post_params":"","short_name":"Google Search","side_image_search_param":"","side_search_param":"","starter_pack_id":0,"suggestions_url":"{google:baseSuggestURL}search?{google:searchFieldtrialParameter}client={google:suggestClient}&gs_ri={google:suggestRid}&xssi=t&q={searchTerms}&{google:inputType}{google:cursorPosition}{google:currentPageUrl}{google:pageClassification}{google:searchVersion}{google:sessionToken}{google:prefetchQuery}sugkey={google:suggestAPIKeyParameter}","suggestions_url_post_params":"","synced_guid":"485bf7d3-0215-45af-87dc-538868000094","url":"{google:baseURL}search?q={searchTerms}&{google:RLZ}{google:originalQueryForSuggestion}{google:assistedQueryStats}{google:searchFieldtrialParameter}{google:searchClient}{google:sourceId}{google:instantExtendedEnabledParameter}{google:contextualSearchVersion}ie={inputEncoding}","usage_count":0}},"devtools"/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Запуск Chrome - Ранее открытые вкладки - руками
#-----------------------------------------------------------------------
# sed -i 's/restore_on_startup":"[A-Za-z0-9]*"/restore_on_startup":"FF7E6D4A0C00443182E8326EE564F803943764462F88443412193C73C8E5046B"/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Языки - отключаем - Использовать Google Переводчик
#-----------------------------------------------------------------------
sed -i 's/"translate_site_blacklist/"translate":{"enabled":false},"translate_site_blacklist/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Скачанные файлы - Всегда указывать место для скачивания
#-----------------------------------------------------------------------
sed -i 's/last_reporting_timestamp":"\([0-9]*\)"},"extensions/last_reporting_timestamp":"\1"},"download":{"prompt_for_download":true},"extensions/g' ~/.config/chromium/Default/Preferences
# sed -i 's/prompt_for_download":false/prompt_for_download":true/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Система - выключить Continue running background apps when Iron is closed
#-----------------------------------------------------------------------
sed -i 's/"browser":/"background_mode":{"enabled":false},"browser":/g' '/home/'$USER'/.config/chromium/Local State'
# sed -i 's/background_mode":{"enabled":true/background_mode":{"enabled":false/g' ~/.config/chromium/Default/Preferences

#-----------------------------------------------------------------------
# Отключаем кэширование на диск # Exec=/usr/share/iron/chrome-wrapper %U
#-----------------------------------------------------------------------
sudo sed -i 's/chrome-wrapper.*/chrome-wrapper --disk-cache-dir=\/dev\/null/g' /usr/share/applications/iron.desktop
sed -i 's/chrome-wrapper %U.*/chrome-wrapper %U --disk-cache-dir=\/dev\/null/g' ~/.local/share/applications/chromium-devel.desktop

#-----------------------------------------------------------------------
## (Предпочтения пользователя) → Приложения → Приложения по умолчанию. Вэб-браузер: ...
#-----------------------------------------------------------------------
sudo rm -vf ~/nohup.out
sudo rm -vf ./nohup.out

echo '------------------------------------------------------------------------------------------------------'
echo '-------------------------------- Настройка SRWare Iron завершена -------------------------------------'
echo '------------------------------------------------------------------------------------------------------'
