#!/bin/bash
# Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2024. All rights reserved. 2-clause BSD license.
# https://fsen.ru/linux/settings#librewolf
# rm -f /tmp/librewolf.sh && wget -qP /tmp https://fsen.ru/inc/doc/linux/librewolf.sh && chmod +x /tmp/librewolf.sh && /tmp/librewolf.sh
#-----------------------------------------------------------------------
# Настраиваем браузер LibreWolf
#-----------------------------------------------------------------------
# Запускаем программу для генерации конфигов по умолчанию               # /usr/bin/librewolf
#-----------------------------------------------------------------------
nohup /usr/share/librewolf/librewolf &
sleep 10
killall -15 librewolf
sleep 5

userdir(){
  local A=$(ls ~/.librewolf/) L='' D=''
  while read L; do
    if [[ "$L" =~ 'default-default' ]]; then D="$L"; break; fi
  done <<< "$(echo -e "$A")"
  echo "$L"
}
U=$(userdir) # abrakadabra.default-default
if [[ "$U" == '' ]]; then echo "Error: do not find config in ~/.librewolf/"; exit 1; fi
U='/home/'$USER'/.librewolf/'$U'/'
D=$U'chrome/'
mkdir -p "$D"
echo -e ":root{--arrowpanel-menuitem-padding:4px 8px 5px !important}\n.tab-background{border-radius:0 !important;border-top-left-radius:5px !important;border-top-right-radius:5px !important;margin-block:0 !important}\n.tab-background[selected=true]{border:2px solid #4eb5ea !important;border-bottom:none !important}" > $D'userChrome.css'
# about:config
# toolkit.legacyUserProfileCustomizations.stylesheets = true
# browser.proton.enabled = false
# Relocate parent directory for browser cache - browser.cache.disk.parent_directory

echo -e 'user_pref("toolkit.legacyUserProfileCustomizations.stylesheets", true);\nuser_pref("browser.proton.enabled", false);\nuser_pref("browser.cache.disk.parent_directory", "/dev/null");' > $U'user.js'

#UTIME=$(date +%s)
#-----------------------------------------------------------------------
# Отключить uBlock Origin
#-----------------------------------------------------------------------
#sed -i 's/"enabled":true/"enabled":false/g' $D'extension-settings.json'

echo -e 'user_pref("extensions.ui.dictionary.hidden", true);\nuser_pref("extensions.ui.extension.hidden", false);\nuser_pref("extensions.ui.lastCategory", "addons://list/extension");\nuser_pref("extensions.ui.locale.hidden", true);\nuser_pref("extensions.ui.sitepermission.hidden", true);' >> $U'user.js'

#-----------------------------------------------------------------------
# Настройки - Основные - Открыть предыдущие окна и вкладки - Включить
#-----------------------------------------------------------------------
#sed -i 's/user_pref\("browser.startup.lastColdStartupCheck", ([0-9]*)\);/user_pref("browser.startup.lastColdStartupCheck", \1);\nuser_pref("browser.startup.page", 3);/g' $D'prefs.js'
echo -e 'user_pref("browser.startup.page", 3);' >> $U'user.js'

#-----------------------------------------------------------------------
# Настройки - Основные - Язык - Русский
#-----------------------------------------------------------------------
echo -e 'user_pref("intl.locale.requested", "ru,en-US");' >> $U'user.js'

#-----------------------------------------------------------------------
#- Настройки - Основные - Проверять орфографию при наборе текста - Отключить
#- Настройки - Основные - Enable fullpage translations - Отключить
#-----------------------------------------------------------------------
#- sed -i 's/user_pref("javascript.use_us_english_locale", true);/user_pref("javascript.use_us_english_locale", true);\nuser_pref("layout.spellcheckDefault", 0);\nuser_pref("browser.translations.enable", false);/g' $D'prefs.js'
echo -e 'user_pref("layout.spellcheckDefault", 0);\nuser_pref("browser.translations.enable", false);' >> $U'user.js'

#-----------------------------------------------------------------------
#- Настройки - Приватность и защита - Удалять куки и данные сайтов при закрытии LibreWolf - Отключить
#-----------------------------------------------------------------------
echo -e 'user_pref("privacy.clearOnShutdown.cache", false);\nuser_pref("privacy.clearOnShutdown.cookies", false);\nuser_pref("privacy.clearOnShutdown.downloads", false);\nuser_pref("privacy.clearOnShutdown.history", false);\nuser_pref("privacy.clearOnShutdown.offlineApps", false);\nuser_pref("privacy.clearOnShutdown.sessions", false);' >> $U'user.js'

#-----------------------------------------------------------------------
# Настройки - Приватность и защита - Не включать режим «Только HTTPS» - Включить
#-----------------------------------------------------------------------
echo -e 'user_pref("dom.security.https_only_mode", false);' >> $U'user.js'

#-----------------------------------------------------------------------
# Настройки - LibreWolf - Enable ResistFingerprinting - Отключить = Чтоб подцеплялись дополнительные шрифты и сайты выглядели по нормальному..
# Настройки - LibreWolf - Silently block canvas access requests - Отключить = Вызывает глюки местами с нажатием элементов
#-----------------------------------------------------------------------
echo -e 'user_pref("privacy.resistFingerprinting", false);\nuser_pref("privacy.resistFingerprinting.autoDeclineNoUserInputCanvasPrompts", false);' >> $U'user.js'

#-----------------------------------------------------------------------
# Запуск чтоб user.js подхватился в настройки $U'prefs.js'
#-----------------------------------------------------------------------
nohup /usr/share/librewolf/librewolf &
sleep 10
killall -15 librewolf
sleep 5

rm -vf $U'user.js' ~/nohup.out

echo '------------------------------------------------------------------------------------------------------'
echo '------------------------------------ Настройка LibreWolf завершена -----------------------------------'
echo '------------------------------------------------------------------------------------------------------'
