#!/bin/bash
# Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2024. All rights reserved. 2-clause BSD license.
# Установщик и настройщик программ и оболочки для KDE Neon User Edition (основан на Ubuntu 22.04 LTS (Jammy Jellyfish) окончание поддержки 04.2027)
# https://fsen.ru/linux/tune  DISTR='jammy' / tune.sh служебный скрипт, вызывается в процесе установки из setup.sh
# rm -f /tmp/tunesoft.sh && wget -qP /tmp https://fsen.ru/inc/doc/linux/tunesoft.sh && chmod +x /tmp/tunesoft.sh && /tmp/tunesoft.sh

#-----------------------------------------------------------------------

if [[ -z $(env | grep '^VOLUME=') ]]; then
  echo '------------------------------------------------------------------------------------------------------'
  echo '------------------------ НАСТРОЙКА ПРЕРВАНА! Вызов не из установщика setup.sh ------------------------'
  echo '------------------------------------------------------------------------------------------------------'
  exit 1;
fi

#-----------------------------------------------------------------------
# Настройка bleachbit     sudo cat /root/.config/bleachbit/bleachbit.ini
#-----------------------------------------------------------------------
if (($(ist "bleachbit"))); then
  sudo mkdir -p /root/.config/bleachbit/
  echo -e '[bleachbit]\nauto_hide = True\ncheck_beta = False\ncheck_online_updates = False\ndark_mode = True\ndebug = False\ndelete_confirmation = True\nexit_done = False\nremember_geometry = True\nshred = False\nunits_iec = False\nwindow_fullscreen = False\nwindow_maximized = True\nfirst_start = False\nversion = 4.4.2\nwindow_x = 0\nwindow_y = 0\nwindow_width = 1920\nwindow_height = 993\nhashsalt = a8cadd182d57f07d71e3b75f5a2a7a9da9a6dfcaf0a2737f72f8aa2e712b79a4728d22d7b297781a9a844bf06cc70dc96cf7d755b31bdb39fb3c4d4c2dec7d7e\n\n[hashpath]\n\n[list/shred_drives]\n0 = /root/.cache\n1 = /tmp\n\n[preserve_languages]\nru = True\nen = True\n\n[tree]\napt = True\napt.autoclean = True\napt.autoremove = True\napt.clean = True\napt.package_lists = True\njournald = True\njournald.clean = True\ndeepscan = True\ndeepscan.backup = True\ndeepscan.tmp = True\nsystem = True\nsystem.clipboard = True\nsystem.tmp = True\nsystem.trash = True\nsystem.cache = True\nsystem.desktop_entry = True\nsystem.memory = True\nsystem.custom = True\nsystem.recent_documents = True\nsystem.rotated_logs = True\n' | sudo tee /root/.config/bleachbit/bleachbit.ini > /dev/null

  mkdir -p ~/.config/bleachbit/
  echo -e '[bleachbit]\nauto_hide = True\ncheck_beta = False\ncheck_online_updates = False\ndark_mode = True\ndebug = False\ndelete_confirmation = True\nexit_done = False\nremember_geometry = True\nshred = False\nunits_iec = False\nwindow_fullscreen = False\nwindow_maximized = True\nfirst_start = False\nversion = 4.4.2\nwindow_x = 0\nwindow_y = 0\nwindow_width = 1920\nwindow_height = 995\nhashsalt = cbd6e87183cc772d0edf3648e0f644a44b85106f1f48dacc99f920592d041f7d89c2049bb6c290d3a1f4371553b0bd7e0b6294a725541e977b54ed48d36dd106\n\n[hashpath]\n\n[list/shred_drives]\n0 = /home/ac/.cache\n1 = /tmp\n\n[preserve_languages]\nen = True\nru = True\n\n[tree]\napt = True\napt.autoclean = True\napt.autoremove = True\napt.clean = True\napt.package_lists = True\nbash = True\nbash.history = True\nchromium = True\nchromium.history = True\nchromium.form_history = True\nchromium.cache = True\nchromium.site_preferences = True\nchromium.passwords = True\nchromium.search_engines = True\nchromium.session = True\nchromium.vacuum = True\nchromium.sync = True\nchromium.dom = True\nfirefox = True\nfirefox.session_restore = True\nfirefox.url_history = True\nfirefox.forms = True\nfirefox.cache = True\nfirefox.crash_reports = True\nfirefox.site_preferences = True\nfirefox.passwords = True\nfirefox.vacuum = True\nfirefox.backup = True\nfirefox.dom = True\ngwenview = True\ngwenview.recent_documents = True\njournald = True\njournald.clean = True\nlibreoffice = True\nlibreoffice.history = True\nlibreoffice.cache = True\nthunderbird = True\nthunderbird.cookies = True\nthunderbird.index = True\nthunderbird.cache = True\nthunderbird.passwords = True\nthunderbird.vacuum = True\nvlc = True\nvlc.memory_dump = True\nvlc.mru = True\nx11 = True\nx11.debug_logs = True\nthumbnails = True\nthumbnails.cache = True\ndeepscan = True\ndeepscan.tmp = True\ndeepscan.backup = True\nsystem = True\nsystem.clipboard = True\nsystem.tmp = True\nsystem.trash = True\nsystem.cache = True\nsystem.desktop_entry = True\nsystem.custom = True\nsystem.recent_documents = True\nsystem.rotated_logs = True\ngoogle_chrome.history = True\ngoogle_chrome = True\ngoogle_chrome.form_history = True\ngoogle_chrome.cache = True\ngoogle_chrome.passwords = True\ngoogle_chrome.search_engines = True\ngoogle_chrome.session = True\ngoogle_chrome.vacuum = True\ngoogle_chrome.sync = True\ngoogle_chrome.dom = True\nopera.history = True\nopera = True\nopera.form_history = True\nopera.cache = True\nopera.passwords = True\nopera.session = True\nopera.vacuum = True\nopera.dom = True\n' > ~/.config/bleachbit/bleachbit.ini
fi

#-----------------------------------------------------------------------
# Настраиваем Audacious
#-----------------------------------------------------------------------
if (($(ist "audacious"))); then
  nohup /usr/bin/audacious > /dev/null 2>&1 & # Запускаем программы для генерации конфигов по умолчанию
  sleep 10
  killall -15 audacious
  sleep 5
  sed -i '/name Audio CD Menu Items/{N;N;N;N;N;s/name Audio CD Menu Items\ndomain audacious-plugins\npriority 0\nabout 0\nconfig 0\nenabled 1/name Audio CD Menu Items\ndomain audacious-plugins\npriority 0\nabout 0\nconfig 0\nenabled 0/}' ~/.config/audacious/plugin-registry
  sed -i '/name MPRIS 2 Server/{N;N;N;N;N;s/name MPRIS 2 Server\ndomain audacious-plugins\npriority 0\nabout 0\nconfig 0\nenabled 1/name MPRIS 2 Server\ndomain audacious-plugins\npriority 0\nabout 0\nconfig 0\nenabled 0/}' ~/.config/audacious/plugin-registry
  sed -i '/name Global Hotkeys/{N;N;N;N;N;s/name Global Hotkeys\ndomain audacious-plugins\npriority 0\nabout 1\nconfig 1\nenabled 0/name Global Hotkeys\ndomain audacious-plugins\npriority 0\nabout 1\nconfig 1\nenabled 1/}' ~/.config/audacious/plugin-registry
  sed -i '/name Status Icon/{N;N;N;N;N;s/name Status Icon\ndomain audacious-plugins\npriority 0\nabout 1\nconfig 1\nenabled 0/name Status Icon\ndomain audacious-plugins\npriority 0\nabout 1\nconfig 1\nenabled 1/}' ~/.config/audacious/plugin-registry
  # выключаем/включаем плагины
  echo -e '\n[globalHotkey]\nHotkey_0_event=0\nHotkey_0_key=11\nHotkey_0_mask=8\nHotkey_0_type=0\nHotkey_10_event=2\nHotkey_10_key=12\nHotkey_10_mask=8\nHotkey_10_type=0\nHotkey_1_event=1\nHotkey_1_key=172\nHotkey_1_mask=0\nHotkey_1_type=0\nHotkey_2_event=3\nHotkey_2_key=174\nHotkey_2_mask=0\nHotkey_2_type=0\nHotkey_3_event=7\nHotkey_3_key=121\nHotkey_3_mask=0\nHotkey_3_type=0\nHotkey_4_event=8\nHotkey_4_key=123\nHotkey_4_mask=0\nHotkey_4_type=0\nHotkey_5_event=9\nHotkey_5_key=122\nHotkey_5_mask=0\nHotkey_5_type=0\nHotkey_6_event=14\nHotkey_6_key=13\nHotkey_6_mask=8\nHotkey_6_type=0\nHotkey_7_event=4\nHotkey_7_key=10\nHotkey_7_mask=8\nHotkey_7_type=0\nHotkey_8_event=2\nHotkey_8_key=12\nHotkey_8_mask=8\nHotkey_8_type=0\nHotkey_9_event=4\nHotkey_9_key=10\nHotkey_9_mask=8\nHotkey_9_type=0\nNumHotkeys=9' >> ~/.config/audacious/config

  kwriteconfig5 --file kglobalshortcutsrc --group kwin --key 'Walk Through Windows of Current Application' 'none,none,Walk Through Windows of Current Application'
  kwriteconfig5 --file kglobalshortcutsrc --group kwin --key 'Walk Through Windows of Current Application (Reverse)' 'none,none,Walk Through Windows of Current Application (Reverse)'

  kwriteconfig5 --file ./audacious/config --group audacious --key enable_replay_gain FALSE
  kwriteconfig5 --file ./audacious/config --group audacious --key generic_title_format '${year}  - ${artist}  - ${?album:${album} - }${title}'
  kwriteconfig5 --file ./audacious/config --group gtkui --key column_widths '54,609,382,35,468,175,23,100,29,53,275,275,275,10,275'
  kwriteconfig5 --file ./audacious/config --group gtkui --key playlist_columns 'number artist year album track title length queued'
  kwriteconfig5 --file ./audacious/config --group gtkui --key playlist_tabs_visible FALSE
  kwriteconfig5 --file ./audacious/config --group statusicon --key scroll_action 1
fi
#-----------------------------------------------------------------------
# Настраиваем SMPlayer
#-----------------------------------------------------------------------
if (($(ist "smplayer"))); then
  nohup /usr/bin/smplayer > /dev/null 2>&1 &
  sleep 10
  killall -15 smplayer
  sleep 5
  # Чего-то он с конфигом натворотил, kwriteconfig5 валит ошибки..
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group gui --key pause_when_hidden --type bool true
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group gui --key close_on_finish --type bool true
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group gui --key iconset blackPanther-Real
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group subtitles --key subcp 'UTF-8'
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group floating_control --key animated --type bool false
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group floating_control --key activation_area 2
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group floating_control --key hide_delay 300
     # kwriteconfig5 --file ./smplayer/playlist.ini --group playlist --key ignore_player_errors --type bool true
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group gui --key auto_add_to_playlist --type bool false
     # kwriteconfig5 --file ./smplayer/playlist.ini --group playlist --key save_playlist_in_config --type bool false
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group tv --key check_channels_conf_on_startup --type bool false
     # kwriteconfig5 --file ./smplayer/smplayer.ini --group update_checker --key enabled --type bool false
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group advanced --key log_mplayer --type bool false
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group advanced --key log_smplayer --type bool false
  #kwriteconfig5 --file ./smplayer/smplayer.ini --group '%General' --key osd 0
  sed -i -e 's/pause_when_hidden=false/pause_when_hidden=true/g' \
    -e 's/close_on_finish=false/close_on_finish=true/g' \
    -e 's/iconset=H2O/iconset=blackPanther-Real/g' \
    -e 's/subcp=ISO-8859-1/subcp=UTF-8/g' \
    -e 's/animated=true/animated=false/g' \
    -e 's/activation_area=1/activation_area=2/g' \
    -e 's/hide_delay=3000/hide_delay=300/g' \
    -e 's/auto_add_to_playlist=true/auto_add_to_playlist=false/g' \
    -e 's/check_channels_conf_on_startup=true/check_channels_conf_on_startup=false/g' \
    -e 's/log_mplayer=true/log_mplayer=false/g' \
    -e 's/log_smplayer=true/log_smplayer=false/g' \
    -e 's/osd=1/osd=0/g' ~/.config/smplayer/smplayer.ini
  echo -e "\n[playlist]\nignore_player_errors=true\nsave_playlist_in_config=false\n\n[update_checker]\nenabled=false\n" >> ~/.config/smplayer/smplayer.ini
fi

#-----------------------------------------------------------------------
# Настраиваем KTorrent (0 = без ограничений)
#-----------------------------------------------------------------------
if (($(ist "ktorrent"))); then
  nohup /usr/bin/ktorrent > /dev/null 2>&1 &
  sleep 10
  killall -15 ktorrent
  sleep 5
  kwriteconfig5 --file ktorrentrc --group downloads --key maxConnections 0
  kwriteconfig5 --file ktorrentrc --group downloads --key maxDownloads 1000
  kwriteconfig5 --file ktorrentrc --group downloads --key maxSeeds 1000
  kwriteconfig5 --file ktorrentrc --group downloads --key maxTotalConnections 0
  kwriteconfig5 --file ktorrentrc --group downloads --key numUploadSlots 100
  kwriteconfig5 --file ktorrentrc --group downloads --key port 3000
fi

if (($(ist "eiskaltdcpp-qt"))); then
  nohup /usr/bin/eiskaltdcpp-qt > /dev/null 2>&1 &
  sleep 10
  killall -15 eiskaltdcpp-qt
  sleep 5
fi

if (($(ist "filezilla"))); then
  nohup /usr/bin/filezilla > /dev/null 2>&1 &
  sleep 10
  killall -15 filezilla
  sleep 5
fi

echo '------------------------------------------------------------------------------------------------------'
echo '------------------------------------- Настройка программ завершена -----------------------------------'
echo '------------------------------------------------------------------------------------------------------'
